Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3967)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3968)
@@ -1395,268 +1418,498 @@
        IMPLICIT NONE
 
-       TYPE(chem_emis_att_type), INTENT(INOUT)                                        :: emt_att
-       TYPE(chem_emis_val_type), ALLOCATABLE, DIMENSION(:), INTENT(INOUT)             :: emt
+       TYPE(chem_emis_att_type), INTENT(INOUT)                             ::  emt_att
+       TYPE(chem_emis_val_type), ALLOCATABLE, DIMENSION(:), INTENT(INOUT)  ::  emt
     
-       INTEGER(iwp)                                     :: ispec                 !< index for number of emission species in input
-
-       INTEGER(iwp)                                     :: num_vars              !< number of variables in netcdf input file
-       INTEGER(iwp)                                     :: len_dims              !< Length of dimension
-
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)          :: dum_var_3d            !< variable for storing temporary data of 3-dimensional 
-                                                                                 !  variables read from netcdf for chemistry emissions
-
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:)        :: dum_var_4d            !< variable for storing temporary data of 5-dimensional
-                                                                                 !< variables read from netcdf for chemistry emissions
-!--
-       !> Start the processing of the data
-
-       !> Parameterized mode of the emissions
-       IF (TRIM(mode_emis)=="PARAMETERIZED" .OR. TRIM(mode_emis)=="parameterized") THEN 
+       INTEGER(iwp)  ::  i, j, k      !< generic counters
+       INTEGER(iwp)  ::  ispec        !< index for number of emission species in input
+       INTEGER(iwp)  ::  len_dims     !< Length of dimension
+       INTEGER(iwp)  ::  num_vars     !< number of variables in netcdf input file
+
+!
+!-- dum_var_4d are designed to read in emission_values from the chemistry netCDF file.
+!-- Currently the vestigial "z" dimension in emission_values makes it a 5D array,
+!-- hence the corresponding dum_var_5d array.  When the "z" dimension is removed
+!-- completely, dum_var_4d will be used instead
+!-- (ecc 20190425) 
+
+!       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:)    ::  dum_var_4d  !< temp array 4 4D chem emission data
+       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:,:)  ::  dum_var_5d  !< temp array 4 5D chem emission data
+
+!
+!-- Start processing data
+
+       CALL location_message( 'starting allocation of chemistry emissions arrays', .FALSE. )
+
+!
+!-- Emission LOD 0 (Parameterized mode)
+
+        IF  ( emiss_lod == 0 )  THEN
+
+! for reference (ecc)
+!       IF (TRIM(mode_emis) == "PARAMETERIZED" .OR. TRIM(mode_emis) == "parameterized") THEN 
 
            ispec=1
-           emt_att%nspec=0
-
-          !number of species
+           emt_att%n_emiss_species = 0
+
+!
+!-- number of species
+
            DO  WHILE (TRIM( surface_csflux_name( ispec ) ) /= 'novalue' )
 
-             emt_att%nspec=emt_att%nspec+1
+             emt_att%n_emiss_species = emt_att%n_emiss_species + 1
              ispec=ispec+1
+!
+!-- followling line retained for compatibility with salsa_mod
+!-- which still uses emt_att%nspec heavily (ecc)
+
+             emt_att%nspec = emt_att%nspec + 1
 
            ENDDO
 
-          !-- allocate emission values data type arrays
-          ALLOCATE(emt(emt_att%nspec))
-
-          !-- Read EMISSION SPECIES NAMES
-
-          !Assign values
-          ALLOCATE(emt_att%species_name(emt_att%nspec))
+!
+!-- allocate emission values data type arrays
+
+          ALLOCATE ( emt(emt_att%n_emiss_species) )
+
+!
+!-- Read EMISSION SPECIES NAMES
+
+!
+!-- allocate space for strings
+
+          ALLOCATE (emt_att%species_name(emt_att%n_emiss_species) )
  
-         DO ispec=1,emt_att%nspec
+         DO ispec = 1, emt_att%n_emiss_species
             emt_att%species_name(ispec) = TRIM(surface_csflux_name(ispec))
          ENDDO
 
-
-       !> DEFAULT AND PRE-PROCESSED MODE
+!
+!-- LOD 1 (default mode) and LOD 2 (pre-processed mode)
+
        ELSE
 
-#if defined ( __netcdf )        
+#if defined ( __netcdf )
+
           IF ( .NOT. input_pids_chem )  RETURN
 
-          !-- Open file in read-only mode
-          CALL open_read_file( TRIM( input_file_chem ) //                       &
-                               TRIM( coupling_char ), id_emis )
-          !-- inquire number of variables
-          CALL inquire_num_variables( id_emis, num_vars )
-
-          !-- Get General Dimension Lengths: only number of species and number of categories.
-          !                                  the other dimensions depend on the mode of the emissions or on the presence of specific components
-          !nspecies
-          CALL netcdf_data_input_get_dimension_length( id_emis, emt_att%nspec, 'nspecies' )
-
+!
+!-- first we allocate memory space for the emission species and then
+!-- we differentiate between LOD 1 (default mode) and LOD 2 (pre-processed mode)
+
+!
+!-- open emission data file ( {palmcase}_chemistry )
+
+          CALL open_read_file ( TRIM(input_file_chem) // TRIM(coupling_char), id_emis )
+
+!
+!-- inquire number of variables
+
+          CALL inquire_num_variables ( id_emis, num_vars )
+
+!
+!-- Get General Dimension Lengths: only # species and # categories.
+!-- Tther dimensions depend on the emission mode or specific components
+
+          CALL netcdf_data_input_get_dimension_length (    &
+                                 id_emis, emt_att%n_emiss_species, 'nspecies' )
+
+!
+!-- backward compatibility for salsa_mod (ecc)
+
+          emt_att%nspec = emt_att%n_emiss_species
+
+! 
+!-- Allocate emission values data type arrays
+
+          ALLOCATE ( emt(emt_att%n_emiss_species) )
+
+!
+!-- READING IN SPECIES NAMES
+
+!
+!-- Allocate memory for species names
+
+          ALLOCATE ( emt_att%species_name(emt_att%n_emiss_species) )
+
+!
+!-- Retrieve variable name (again, should use n_emiss_strlen)
+
+          CALL get_variable( id_emis, 'emission_name',    &
+                             string_values, emt_att%n_emiss_species )
+          emt_att%species_name=string_values
+
+!
+!-- dealocate string_values previously allocated in get_variable call
+
+          IF  ( ALLOCATED(string_values) )  DEALLOCATE (string_values)
+
+!
+!-- READING IN SPECIES INDICES
+
+!
+!-- Allocate memory for species indices
+
+          ALLOCATE ( emt_att%species_index(emt_att%n_emiss_species) )
+
+!
+!-- Retrieve variable data
+
+          CALL get_variable( id_emis, 'emission_index', emt_att%species_index )
+!
+!-- Now the routine has to distinguish between chemistry emission
+!-- LOD 1 (DEFAULT mode) and LOD 2 (PRE-PROCESSED mode) 
+
+!
+!-- START OF EMISSION LOD 1 (DEFAULT MODE)
+
+
+          IF  ( emiss_lod == 1 )  THEN
+
+! for reference (ecc)
+!          IF (TRIM(mode_emis) == "DEFAULT" .OR. TRIM(mode_emis) == "default") THEN
+
+! 
+!-- get number of emission categories
+
+             CALL netcdf_data_input_get_dimension_length (           &
+                                    id_emis, emt_att%ncat, 'ncat' )
+
+!-- READING IN EMISSION CATEGORIES INDICES
+
+             ALLOCATE ( emt_att%cat_index(emt_att%ncat) )
+
+!
+!-- Retrieve variable data
+
+             CALL get_variable( id_emis, 'emission_cat_index', emt_att%cat_index )
+
+
+!
+!-- Loop through individual species to get basic information on
+!-- VOC/PM/NOX/SOX
+
+!------------------------------------------------------------------------------
+!-- NOTE - CHECK ARRAY INDICES FOR READING IN NAMES AND SPECIES
+!--        IN LOD1 (DEFAULT MODE) FOR THE VARIOUS MODE SPLITS
+!--        AS ALL ID_EMIS CONDITIONALS HAVE BEEN REMOVED FROM GET_VAR
+!--        FUNCTIONS.  IN THEORY THIS WOULD MEAN ALL ARRAYS SHOULD BE
+!--        READ FROM 0 to N-1 (C CONVENTION) AS OPPOSED TO 1 to N
+!--        (FORTRAN CONVENTION).  KEEP THIS IN MIND !!
+!--        (ecc 20190424)
+!------------------------------------------------------------------------------
  
-          !-- Allocate emission values data type arrays
-          ALLOCATE(emt(1:emt_att%nspec))
-
-
-          !-- Read EMISSION SPECIES NAMES
-          !Allocate Arrays 
-          ALLOCATE(emt_att%species_name(emt_att%nspec)) 
-
-          !Call get Variable
-          CALL get_variable( id_emis, 'emission_name', string_values, emt_att%nspec )
-          emt_att%species_name=string_values
-          ! If allocated, Deallocate var_string, an array only used for reading-in strings
-          IF (ALLOCATED(string_values)) DEALLOCATE(string_values) 
-
-          !-- Read EMISSION SPECIES INDEX
-          !Allocate Arrays 
-          ALLOCATE(emt_att%species_index(emt_att%nspec))
-          !Call get Variable
-          CALL get_variable( id_emis, 'emission_index', emt_att%species_index )
-
-
-          !-- Now the routine has to distinguish between DEFAULT and PRE-PROCESSED chemistry emission modes
-
-          IF (TRIM(mode_emis)=="DEFAULT" .OR. TRIM(mode_emis)=="default") THEN
+             DO  ispec = 1, emt_att%n_emiss_species
+
+!
+!-- VOC DATA (name and composition)
+
+                IF  ( TRIM(emt_att%species_name(ispec)) == "VOC" .OR.                  &
+                      TRIM(emt_att%species_name(ispec)) == "voc" )  THEN
+
+!
+!-- VOC name
+                   CALL netcdf_data_input_get_dimension_length (     &
+                                          id_emis, emt_att%nvoc, 'nvoc' )
+                   ALLOCATE ( emt_att%voc_name(emt_att%nvoc) )
+                   CALL get_variable ( id_emis,"emission_voc_name",  &
+                                       string_values, emt_att%nvoc )
+                   emt_att%voc_name = string_values
+                   IF  ( ALLOCATED(string_values) )  DEALLOCATE (string_values)
+
+! 
+!-- VOC composition
+
+                   ALLOCATE ( emt_att%voc_comp(emt_att%ncat,emt_att%nvoc) )
+                   CALL get_variable ( id_emis, "composition_voc", emt_att%voc_comp,     &
+                                       1, emt_att%ncat, 1, emt_att%nvoc )
+
+                ENDIF  ! VOC
+
+!
+!-- PM DATA (name and composition)
+
+                IF  ( TRIM(emt_att%species_name(ispec)) == "PM" .OR.                   &
+                      TRIM(emt_att%species_name(ispec)) == "pm")  THEN
+
+!
+!-- PM name
+
+                   CALL netcdf_data_input_get_dimension_length (     &
+                                          id_emis, emt_att%npm, 'npm' )
+                   ALLOCATE ( emt_att%pm_name(emt_att%npm) )
+                   CALL get_variable ( id_emis, "pm_name", string_values, emt_att%npm )
+                   emt_att%pm_name = string_values
+                   IF  ( ALLOCATED(string_values) )  DEALLOCATE (string_values)      
+
+!
+!-- PM composition (PM1, PM2.5 and PM10)
+
+                   len_dims = 3  ! PM1, PM2.5, PM10
+                   ALLOCATE(emt_att%pm_comp(emt_att%ncat,emt_att%npm,len_dims))
+                   CALL get_variable ( id_emis, "composition_pm", emt_att%pm_comp,       &
+                                       1, emt_att%ncat, 1, emt_att%npm, 1, len_dims )
+
+                ENDIF  ! PM
+
+!
+!-- NOX (NO and NO2)
+
+                IF  ( TRIM(emt_att%species_name(ispec)) == "NOX" .OR.                  &
+                      TRIM(emt_att%species_name(ispec)) == "nox" )  THEN
+
+                   ALLOCATE ( emt_att%nox_comp(emt_att%ncat,emt_att%nnox) )
+                   CALL get_variable ( id_emis, "composition_nox", emt_att%nox_comp,     &
+                                       1, emt_att%ncat, 1, emt_att%nnox )
+
+                ENDIF  ! NOX
+
+!
+!-- SOX (SO2 and SO4)
+
+                IF  ( TRIM(emt_att%species_name(ispec)) == "SOX" .OR.                  &
+                      TRIM(emt_att%species_name(ispec)) == "sox" )  THEN
+
+                   ALLOCATE ( emt_att%sox_comp(emt_att%ncat,emt_att%nsox) )
+                   CALL get_variable ( id_emis, "composition_sox", emt_att%sox_comp,     &
+                                       1, emt_att%ncat, 1, emt_att%nsox )
+
+                ENDIF  ! SOX
+
+             ENDDO  ! do ispec
+
+!
+!-- EMISSION TIME SCALING FACTORS (hourly and MDH data)
  
-             !number of categories
-             CALL netcdf_data_input_get_dimension_length( id_emis, emt_att%ncat, 'ncat' )
-
-             !-- Read EMISSION CATEGORIES INDEX
-             !Allocate Arrays 
-             ALLOCATE(emt_att%cat_index(emt_att%ncat))
-             !Call get Variable
-             CALL get_variable( id_emis, 'emission_cat_index', emt_att%cat_index )
-
+!     
+!-- HOUR   
+             IF  ( TRIM(time_fac_type) == "HOUR" .OR.                        &
+                   TRIM(time_fac_type) == "hour" )  THEN
+
+                CALL netcdf_data_input_get_dimension_length (                  &
+                                       id_emis, emt_att%nhoursyear, 'nhoursyear' )
+                ALLOCATE ( emt_att%hourly_emis_time_factor(emt_att%ncat,emt_att%nhoursyear) )
+                CALL get_variable ( id_emis, "emission_time_factors",          &
+                                    emt_att%hourly_emis_time_factor,           &
+                                    1, emt_att%ncat, 1, emt_att%nhoursyear )
+
+!
+!-- MDH
+
+             ELSE IF  ( TRIM(time_fac_type)  ==  "MDH" .OR.                  &
+                        TRIM(time_fac_type)  ==  "mdh" )  THEN
+
+                CALL netcdf_data_input_get_dimension_length (                  &
+                                       id_emis, emt_att%nmonthdayhour, 'nmonthdayhour' )
+                ALLOCATE ( emt_att%mdh_emis_time_factor(emt_att%ncat,emt_att%nmonthdayhour) )
+                CALL get_variable ( id_emis, "emission_time_factors",          &
+                                    emt_att%mdh_emis_time_factor,              &
+                                    1, emt_att%ncat, 1, emt_att%nmonthdayhour )
+
+!
+!-- ERROR (time factor undefined)
+
+             ELSE
+
+                message_string = 'We are in the DEFAULT chemistry emissions mode: '  //  &
+                                 '     !no time-factor type specified!'              //  &
+                                 'Please specify the value of time_fac_type:'        //  &
+                                 '         either "MDH" or "HOUR"'                  
+                CALL message( 'netcdf_data_input_chemistry_data', 'CM0200', 2, 2, 0, 6, 0 ) 
  
-             DO ispec=1,emt_att%nspec
-                !-- EMISSION_VOC_NAME (1-DIMENSIONAL)
-                IF (TRIM(emt_att%species_name(ispec))=="VOC" .OR. TRIM(emt_att%species_name(ispec))=="voc") THEN
-                   !Allocate Array
-                   CALL netcdf_data_input_get_dimension_length( id_emis, emt_att%nvoc, 'nvoc' )
-                   ALLOCATE(emt_att%voc_name(1:emt_att%nvoc))
-                   !Read-in Variable
-                   CALL get_variable( id_emis,"emission_voc_name",string_values, emt_att%nvoc)
-                   emt_att%voc_name=string_values
-                   IF (ALLOCATED(string_values)) DEALLOCATE(string_values)
+
+             ENDIF  ! time_fac_type
+
+!
+!-- read in default (LOD1) emissions from chemisty netCDF file per species
+
+!
+!-- NOTE - at the moment the data is read in per species, but in the future it would
+!--        be much more sensible to read in per species per time step to reduce
+!--        memory consumption and, to a lesser degree, dimensionality of data exchange
+!--        (I expect this will be necessary when the problem size is large)
+
+             DO ispec = 1, emt_att%n_emiss_species
+
+!
+!-- allocate space for species specific emission values
+!-- NOTE - this array is extended by 1 cell in each horizontal direction
+!--        to compensate for an apparent linear offset.  The reason of this
+!--        offset is not known but it has been determined to take place beyond the
+!--        scope of this module, and has little to do with index conventions.
+!--        That is, setting the array horizontal limit from nx0:nx1 to 1:(nx1-nx0+1)
+!--        or nx0+1:nx1+1 did not result in correct or definite behavior
+!--        This must be looked at at some point by the Hannover team but for now
+!--        this workaround is deemed reasonable (ecc 20190417)
+
+                IF ( .NOT. ALLOCATED ( emt(ispec)%default_emission_data ) )  THEN
+                    ALLOCATE ( emt(ispec)%default_emission_data(emt_att%ncat,nys:nyn+1,nxl:nxr+1) )
+                ENDIF
+!
+!-- allocate dummy variable w/ index order identical to that shown in the netCDF header
+
+                ALLOCATE ( dum_var_5d(1,nys:nyn,nxl:nxr,1,emt_att%ncat) )
+!
+!-- get variable.  be very careful
+!-- I am using get_variable_5d_real_dynamic (note logical argument at the end)
+!-- 1) use Fortran index convention (i.e., 1 to N)
+!-- 2) index order must be in reverse order from above allocation order
  
-                !-- COMPOSITION VOC (2-DIMENSIONAL)
-                   !Allocate Array 
-                   ALLOCATE(emt_att%voc_comp(1:emt_att%ncat,1:emt_att%nvoc))
-                   !Read-in Variable
-!               CALL get_variable(id_emis,"composition_voc",emt%voc_comp,1,1,emt%ncat,emt%nvoc)
-                   CALL get_variable(id_emis,"composition_voc",emt_att%voc_comp,1,emt_att%ncat,1,emt_att%nvoc)
+                CALL get_variable ( id_emis, "emission_values", dum_var_5d, &
+                                    1,            ispec, nxl+1,     nys+1,     1,                    &
+                                    emt_att%ncat, 1,     nxr-nxl+1, nyn-nys+1, emt_att%dt_emission,  &
+                                    .FALSE. )
+!
+!-- assign temp array to data structure then deallocate temp array
+!-- NOTE - indices are shifted from nx0:nx1 to nx0+1:nx1+1 to offset
+!--        the emission data array to counter said domain offset
+!--        (ecc 20190417)
+
+                DO k = 1, emt_att%ncat
+                   DO j = nys+1, nyn+1
+                      DO i = nxl+1, nxr+1
+                         emt(ispec)%default_emission_data(k,j,i) = dum_var_5d(1,j-1,i-1,1,k)
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+                DEALLOCATE ( dum_var_5d )
+
+             ENDDO  ! ispec
+!
+!-- UNITS
+
+             CALL get_attribute(id_emis,"units",emt_att%units,.FALSE.,"emission_values")
+
+!
+!-- END DEFAULT MODE
+
+
+!
+!-- START LOD 2 (PRE-PROCESSED MODE)
+
+          ELSE IF  ( emiss_lod == 2 )  THEN
+
+! for reference (ecc)
+!          ELSE IF (TRIM(mode_emis) == "PRE-PROCESSED" .OR. TRIM(mode_emis) == "pre-processed") THEN
+
+!
+!-- For LOD 2 only VOC and emission data need be read
+
+!------------------------------------------------------------------------------
+!-- NOTE - CHECK ARRAY INDICES FOR READING IN NAMES AND SPECIES
+!--        IN LOD2 (PRE-PROCESSED MODE) FOR THE VARIOUS MODE SPLITS
+!--        AS ALL ID_EMIS CONDITIONALS HAVE BEEN REMOVED FROM GET_VAR
+!--        FUNCTIONS.  IN THEORY THIS WOULD MEAN ALL ARRAYS SHOULD BE
+!--        READ FROM 0 to N-1 (C CONVENTION) AS OPPOSED TO 1 to N
+!--        (FORTRAN CONVENTION).  KEEP THIS IN MIND !!
+!--        (ecc 20190424)
+!------------------------------------------------------------------------------
+
+             DO ispec = 1, emt_att%n_emiss_species
+
+!
+!-- VOC DATA (name and composition)
+
+                IF  ( TRIM(emt_att%species_name(ispec)) == "VOC" .OR.                  &
+                      TRIM(emt_att%species_name(ispec)) == "voc" )  THEN
+
+!
+!-- VOC name
+                   CALL netcdf_data_input_get_dimension_length (                         &
+                                          id_emis, emt_att%nvoc, 'nvoc' )
+                   ALLOCATE ( emt_att%voc_name(emt_att%nvoc) )
+                   CALL get_variable ( id_emis, "emission_voc_name",                     &
+                                       string_values, emt_att%nvoc)
+                   emt_att%voc_name = string_values
+                   IF  ( ALLOCATED(string_values) )  DEALLOCATE (string_values)
+
+!
+!-- VOC composition
+ 
+                   ALLOCATE ( emt_att%voc_comp(emt_att%ncat,emt_att%nvoc) )
+                   CALL get_variable ( id_emis, "composition_voc", emt_att%voc_comp,     &
+                                       1, emt_att%ncat, 1, emt_att%nvoc )
+                ENDIF  ! VOC
+  
+             ENDDO  ! ispec
+
+!
+!-- EMISSION DATA
+
+             CALL netcdf_data_input_get_dimension_length (                               &
+                                    id_emis, emt_att%dt_emission, 'time' )   
+ 
+!
+!-- read in pre-processed (LOD2) emissions from chemisty netCDF file per species
+
+!
+!-- NOTE - at the moment the data is read in per species, but in the future it would
+!--        be much more sensible to read in per species per time step to reduce
+!--        memory consumption and, to a lesser degree, dimensionality of data exchange
+!--        (I expect this will be necessary when the problem size is large)
+
+             DO ispec = 1, emt_att%n_emiss_species
+
+!
+!-- allocate space for species specific emission values
+!-- NOTE - this array is extended by 1 cell in each horizontal direction
+!--        to compensate for an apparent linear offset.  The reason of this
+!--        offset is not known but it has been determined to take place beyond the
+!--        scope of this module, and has little to do with index conventions.
+!--        That is, setting the array horizontal limit from nx0:nx1 to 1:(nx1-nx0+1)
+!--        or nx0+1:nx1+1 did not result in correct or definite behavior
+!--        This must be looked at at some point by the Hannover team but for now
+!--        this workaround is deemed reasonable (ecc 20190417)
+
+                IF ( .NOT. ALLOCATED( emt(ispec)%preproc_emission_data ) )  THEN
+                   ALLOCATE( emt(ispec)%preproc_emission_data(                           &
+                             emt_att%dt_emission, 1, nys:nyn+1, nxl:nxr+1) )
                 ENDIF
-
-                !-- EMISSION_PM_NAME (1-DIMENSIONAL)
-                IF (TRIM(emt_att%species_name(ispec))=="PM" .OR. TRIM(emt_att%species_name(ispec))=="pm") THEN
-                   CALL netcdf_data_input_get_dimension_length( id_emis, emt_att%npm, 'npm' )
-                   ALLOCATE(emt_att%pm_name(1:emt_att%npm))
-                   !Read-in Variable
-                   CALL get_variable( id_emis,"pm_name",string_values, emt_att%npm)
-                   emt_att%pm_name=string_values
-                   IF (ALLOCATED(string_values)) DEALLOCATE(string_values)      
-
-                !-- COMPOSITION PM (3-DIMENSIONAL)
-                   !Allocate
-                   len_dims=3  !> number of PMs: PM1, PM2.5 and PM10
-                   ALLOCATE(emt_att%pm_comp(1:emt_att%ncat,1:emt_att%npm,1:len_dims))
-                   !Read-in Variable
-                   CALL get_variable(id_emis,"composition_pm",emt_att%pm_comp,1,emt_att%ncat,1,emt_att%npm,1,len_dims)                    
-                ENDIF
-
-                !-- COMPOSITION_NOX (2-DIMENSIONAL)
-                IF (TRIM(emt_att%species_name(ispec))=="NOx" .OR. TRIM(emt_att%species_name(ispec))=="nox") THEN
-                   !Allocate array
-                   ALLOCATE(emt_att%nox_comp(1:emt_att%ncat,1:emt_att%nnox))
-                   !Read-in Variable
-                   CALL get_variable(id_emis,"composition_nox",emt_att%nox_comp,1,emt_att%ncat,1,emt_att%nnox)
-                ENDIF
-
-                !-- COMPOSITION-SOX (2-DIMENSIONAL)
-                IF (TRIM(emt_att%species_name(ispec))=="SOx" .OR. TRIM(emt_att%species_name(ispec))=="sox") THEN
-                   ALLOCATE(emt_att%sox_comp(1:emt_att%ncat,1:emt_att%nsox))
-                   !Read-in Variable
-                   CALL get_variable(id_emis,"composition_sox",emt_att%sox_comp,1,emt_att%ncat,1,emt_att%nsox)
-                ENDIF
-             ENDDO !>ispec
-
-!-- For reading the emission time factors, the distinction between HOUR and MDH data is necessary
-      
-             !-- EMISSION_TIME_SCALING_FACTORS
-                !-- HOUR   
-             IF (TRIM(time_fac_type)=="HOUR" .OR. TRIM(time_fac_type)=="hour") THEN
-                !-- Allocate Array
-                CALL netcdf_data_input_get_dimension_length( id_emis, emt_att%nhoursyear, 'nhoursyear' )
-                ALLOCATE(emt_att%hourly_emis_time_factor(1:emt_att%ncat,1:emt_att%nhoursyear))
-                !Read-in Variable
-                CALL get_variable(id_emis,"emission_time_factors",emt_att%hourly_emis_time_factor,1,   &
-                                  emt_att%ncat,1,emt_att%nhoursyear)
-
-                !-- MDH
-             ELSE IF (TRIM(time_fac_type) == "MDH" .OR. TRIM(time_fac_type) == "mdh") THEN
-                !-- Allocate Array
-                CALL netcdf_data_input_get_dimension_length( id_emis, emt_att%nmonthdayhour, 'nmonthdayhour' )
-                ALLOCATE(emt_att%mdh_emis_time_factor(1:emt_att%ncat,1:emt_att%nmonthdayhour))
-                !-- Read-in Variable
-                CALL get_variable(id_emis,"emission_time_factors",emt_att%mdh_emis_time_factor,1,       &
-                                  emt_att%ncat,1,emt_att%nmonthdayhour)
-
-             ELSE
-
-             message_string = 'We are in the DEFAULT chemistry emissions mode: '            //          &
-                              '     !no time-factor type specified!'                        //          &
-                              'Please, specify the value of time_fac_type:'                 //          &
-                              '         either "MDH" or "HOUR"'                  
-             CALL message( 'netcdf_data_input_chemistry_data', 'CM0200', 2, 2, 0, 6, 0 ) 
- 
-
-             ENDIF
-
-             !-- Finally read-in the emission values and their units (DEFAULT mode)
-
-             DO ispec=1,emt_att%nspec
-
-                IF ( .NOT. ALLOCATED( emt(ispec)%default_emission_data ) )                              &
-                    ALLOCATE(emt(ispec)%default_emission_data(1:emt_att%ncat,1:ny+1,1:nx+1))
-
-                ALLOCATE(dum_var_3d(1:emt_att%ncat,nys+1:nyn+1,nxl+1:nxr+1))
-
-                CALL get_variable(id_emis,"emission_values",dum_var_3d,ispec,1,emt_att%ncat,nys,nyn,nxl,nxr)          
-
-                emt(ispec)%default_emission_data(:,nys+1:nyn+1,nxl+1:nxr+1) =                           &
-                    dum_var_3d(1:emt_att%ncat,nys+1:nyn+1,nxl+1:nxr+1)
-
-                DEALLOCATE (dum_var_3d)
-
-             ENDDO
-
-             !-- UNITS
-             CALL get_attribute(id_emis,"units",emt_att%units,.FALSE.,"emission_values")
-
-
-          !-- PRE-PROCESSED MODE --
-
-          ELSE IF (TRIM(mode_emis)=="PRE-PROCESSED" .OR. TRIM(mode_emis)=="pre-processed") THEN
-          !-- In the PRE-PROCESSED mode, only the VOC names, the VOC_composition, the emission values and their units remain to be read at this point
-
-             DO ispec=1,emt_att%nspec
-
-             !-- EMISSION_VOC_NAME (1-DIMENSIONAL)
-                IF (TRIM(emt_att%species_name(ispec))=="VOC" .OR. TRIM(emt_att%species_name(ispec))=="voc") THEN
-                   !Allocate Array
-                   CALL netcdf_data_input_get_dimension_length( id_emis, emt_att%nvoc, 'nvoc' )
-                   ALLOCATE(emt_att%voc_name(1:emt_att%nvoc))
-                   !Read-in Variable
-                   CALL get_variable( id_emis,"emission_voc_name",string_values, emt_att%nvoc)
-                   emt_att%voc_name=string_values
-                   IF (ALLOCATED(string_values)) DEALLOCATE(string_values)
- 
-             !-- COMPOSITION VOC (2-DIMENSIONAL)
-                   !Allocate Array 
-                   ALLOCATE(emt_att%voc_comp(1:emt_att%ncat,1:emt_att%nvoc))
-                   !Read-in Variable
-                   CALL get_variable(id_emis,"composition_voc",emt_att%voc_comp,1,emt_att%ncat,1,emt_att%nvoc)
-                ENDIF
-  
-             ENDDO !> ispec
-
-             !-- EMISSION_VALUES (4-DIMENSIONAL)
-             !Calculate temporal dimension length
-             CALL netcdf_data_input_get_dimension_length( id_emis, emt_att%dt_emission, 'time' )   
-         
-
-             DO ispec=1,emt_att%nspec
-
-                !Allocation for the entire domain has to be done only for the first processor between all the subdomains     
-                IF ( .NOT. ALLOCATED( emt(ispec)%preproc_emission_data ) )                              &
-                    ALLOCATE(emt(ispec)%preproc_emission_data(emt_att%dt_emission,1,1:ny+1,1:nx+1))
-
-                !> allocate variable where to pass emission values read from netcdf
-                ALLOCATE(dum_var_4d(1:emt_att%dt_emission,1,nys+1:nyn+1,nxl+1:nxr+1))
-
-                !Read-in Variable 
-                CALL get_variable(id_emis,"emission_values",dum_var_4d,ispec,1,emt_att%dt_emission,1,1,nys,nyn,nxl,nxr)          
-
-      
-                emt(ispec)%preproc_emission_data(:,1,nys+1:nyn+1,nxl+1:nxr+1) =                         &
-                      dum_var_4d(1:emt_att%dt_emission,1,nys+1:nyn+1,nxl+1:nxr+1)
-
-                DEALLOCATE ( dum_var_4d )
-
-             ENDDO
-
-             !-- UNITS
-             CALL get_attribute(id_emis,"units",emt_att%units,.FALSE.,"emission_values")
+!
+!-- allocate dummy variable w/ index order identical to that shown in the netCDF header
+
+                ALLOCATE ( dum_var_5d(emt_att%dt_emission,1,nys:nyn,nxl:nxr,1) )
+!
+!-- get variable.  be very careful
+!-- I am using get_variable_5d_real_dynamic (note logical argument at the end)
+!-- 1) use Fortran index convention (i.e., 1 to N)
+!-- 2) index order must be in reverse order from above allocation order
+
+                CALL get_variable ( id_emis, "emission_values", dum_var_5d, &
+                                    ispec, nxl+1,     nys+1,     1, 1,                   &
+                                    1,     nxr-nxl+1, nyn-nys+1, 1, emt_att%dt_emission, &
+                                    .FALSE. )
+!
+!-- assign temp array to data structure then deallocate temp array
+!-- NOTE - indices are shifted from nx0:nx1 to nx0+1:nx1+1 to offset
+!--        the emission data array to counter said unkonwn offset
+!--        (ecc 20190417)
+
+                DO k = 1, emt_att%dt_emission
+                   DO j = nys+1, nyn+1
+                      DO i = nxl+1, nxr+1
+                         emt(ispec)%preproc_emission_data(k,1,j,i) = dum_var_5d(k,1,j-1,i-1,1)
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+                DEALLOCATE ( dum_var_5d )
+
+             ENDDO  ! ispec
+!
+!-- UNITS
+
+             CALL get_attribute ( id_emis, "units", emt_att%units, .FALSE. , "emission_values" )
        
-          ENDIF
-
-       CALL close_input_file( id_emis )
+          ENDIF  ! LOD1 & LOD2 (default and pre-processed mode)
+
+          CALL close_input_file (id_emis)
 
 #endif
-       ENDIF
+
+       ENDIF ! LOD0 (parameterized mode)
 
     END SUBROUTINE netcdf_data_input_chemistry_data
+
 
 !------------------------------------------------------------------------------!
